-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_CapStrokes"

-- **************************************************
-- General information about this script
-- **************************************************

DS_CapStrokes = {}

function DS_CapStrokes:Name()
	return "Set round edges"
end

function DS_CapStrokes:Version()
	return "0.1"
end

function DS_CapStrokes:Description()
	return "Set round caps on strokes"
end

function DS_CapStrokes:Creator()
	return "dauid.com"
end

function DS_CapStrokes:UILabel()
	return("Set round edges")
end
-- **************************************************
-- Recurring values
-- **************************************************

DS_CapStrokes.round = true
DS_CapStrokes.allLayers = false

--************************menu
local DS_RoundDialog = {}

DS_RoundDialog.UPDATE = MOHO.MSG_BASE

function DS_RoundDialog:new(moho)

	local d = LM.GUI.SimpleDialog("Settings", DS_RoundDialog)
	local l = d:GetLayout()
	
	d.moho = moho
	
	l:PushH()
		l:PushV()
			d.roundBox = LM.GUI.RadioButton("Round edges")
			l:AddChild(d.roundBox, LM.GUI.ALIGN_LEFT)
			d.roundBox:SetValue(DS_CapStrokes.round)
			d.squareBox = LM.GUI.RadioButton("Not round edges")
			l:AddChild(d.squareBox, LM.GUI.ALIGN_LEFT)
			d.allBox = LM.GUI.CheckBox("All layers")
			l:AddChild(d.allBox, LM.GUI.ALIGN_LEFT)
		l:Pop()
	l:Pop()

	return d
end

function DS_RoundDialog:UpdateWidgets()
	self.roundBox:SetValue(DS_CapStrokes.round)
	if DS_CapStrokes.round then
		self.squareBox:SetValue(false)
	else
		self.squareBox:SetValue(true)
	end
	self.allBox:SetValue(DS_CapStrokes.allLayers)
end

function DS_RoundDialog:OnOK()
DS_CapStrokes.round = self.roundBox:Value()
DS_CapStrokes.allLayers = self.allBox:Value()
end

-- **************************************************
-- The guts of this script
-- **************************************************

function DS_CapStrokes:capping(moho)
local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end
	
	for i=0, mesh:CountShapes()-1 do
	local theShape=mesh:Shape(i)
		if self.round then
			theShape.fMyStyle.fLineCaps=1
		else
			theShape.fMyStyle.fLineCaps=0
		end
	end
end

function DS_CapStrokes:allTheLayers(moho, layer, top)

    local i
    local num_layers

    if not top then
		
		self:capping(moho)
    end

    if layer.CountLayers ~= nil then
        num_layers = layer:CountLayers()
    elseif layer:IsGroupType() then
        num_layers = moho:LayerAsGroup(layer):CountLayers()
    else
        num_layers = 0
    end

    for i = 0, num_layers-1 do
		 moho:SetSelLayer(layer:Layer(i))
        self:allTheLayers(moho, layer:Layer(i), false)
    end
    
end


function DS_CapStrokes:Run(moho)
local dlog = DS_RoundDialog:new(moho)
	if (dlog:DoModal() == LM.GUI.MSG_CANCEL) then
		return
	end
	
    local layer = moho.layer
	
	moho.document:PrepMultiUndo()
	moho.document:SetDirty()

	if self.allLayers then
		self:allTheLayers(moho, moho.document, true)
else
		self:capping(moho)
	end
    

end
