-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_vignette"

-- **************************************************
-- General information about this script
-- **************************************************

DS_vignette = {}
function DS_vignette:Name()
	return "Vignette"
end

function DS_vignette:Version()
	return "1.0"
end

function DS_vignette:Description()
	return "Creates a layer with a vignetting effect"
end

function DS_vignette:Creator()
	return "dauid.com"
end

function DS_vignette:UILabel()
	return("Vignette")
end
-- **************************************************
-- Recurring values
-- **************************************************



-- **************************************************
-- The guts of this script
-- **************************************************

function DS_vignette:OnMouseDown(moho, mouseEvent)
	self:Run(moho)
end

function DS_vignette:Run(moho)
local vigLayer = (moho:CreateNewLayer(MOHO.LT_VECTOR))
vigLayer:SetName("Vignette")

	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end
	theAspect=moho.document:AspectRatio()
	local FillColor = LM.ColorVector:new_local() 
	FillColor:Set(0.0, 0.0, 0.0) 
	
	self:BuildPolygon(mesh)
	local id=moho:CreateShape(true)
	mesh:Shape(id).fMyStyle.fFillCol:SetValue(0, FillColor:AsColorStruct())
	mesh:Shape(id).fHasOutline = false
	mesh:Shape(id).fMyStyle.fGradient=true
local v = LM.Vector3:new_local()
v.x = theAspect
v.y = 1
v.z = 0
vigLayer.fScale:SetValue(0, v)



	

end

function DS_vignette:BuildPolygon(mesh)
	
	local v = LM.Vector2:new_local()
	mesh:SelectNone()
	
	v.x=-1
	v.y=1
	
local pointOne=(mesh:AddLonePoint(v, 0))
	v.x=1
	v.y=1
local pointTwo=(mesh:AppendPoint(v, 0))

	v.x=1
	v.y=-1
local pointThree=(mesh:AppendPoint(v, 0))

	v.x=-1
	v.y=-1
local pointFour=(mesh:AppendPoint(v, 0))

	v.x=-1
	v.y=1
local pointFive=(mesh:AppendPoint(v, 0))
	
mesh:WeldPoints(0, 4, 0)

	for i = 0, 3 do
		mesh:Point(i):SetCurvature(MOHO.PEAKED, 0)
	end

	mesh:SelectConnected()
end